/* Generated by wayland-scanner 1.20.0 */

#ifndef WEBOS_EXTENSION_SERVER_PROTOCOL_H
#define WEBOS_EXTENSION_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_webos_extension The webos_extension protocol
 * @section page_ifaces_webos_extension Interfaces
 * - @subpage page_iface_wl_webos_xinput - interface for adding extended inputs
 * - @subpage page_iface_wl_webos_xinput_extension - interface for registering a new xinput extension
 * @section page_copyright_webos_extension Copyright
 * <pre>
 *
 * Copyright (c) 2013-2020 LG Electronics, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * SPDX-License-Identifier: Apache-2.0
 * </pre>
 */
struct wl_webos_xinput;
struct wl_webos_xinput_extension;

#ifndef WL_WEBOS_XINPUT_INTERFACE
#define WL_WEBOS_XINPUT_INTERFACE
/**
 * @page page_iface_wl_webos_xinput wl_webos_xinput
 * @section page_iface_wl_webos_xinput_desc Description
 *
 * xinput stands for an extended input which allows a client
 * to pass an input event to another client.
 * @section page_iface_wl_webos_xinput_api API
 * See @ref iface_wl_webos_xinput.
 */
/**
 * @defgroup iface_wl_webos_xinput The wl_webos_xinput interface
 *
 * xinput stands for an extended input which allows a client
 * to pass an input event to another client.
 */
extern const struct wl_interface wl_webos_xinput_interface;
#endif
#ifndef WL_WEBOS_XINPUT_EXTENSION_INTERFACE
#define WL_WEBOS_XINPUT_EXTENSION_INTERFACE
/**
 * @page page_iface_wl_webos_xinput_extension wl_webos_xinput_extension
 * @section page_iface_wl_webos_xinput_extension_desc Description
 *
 * This interface is used for registering a new xinput extension.
 * @section page_iface_wl_webos_xinput_extension_api API
 * See @ref iface_wl_webos_xinput_extension.
 */
/**
 * @defgroup iface_wl_webos_xinput_extension The wl_webos_xinput_extension interface
 *
 * This interface is used for registering a new xinput extension.
 */
extern const struct wl_interface wl_webos_xinput_extension_interface;
#endif

#ifndef WL_WEBOS_XINPUT_KEYSYM_TYPE_ENUM
#define WL_WEBOS_XINPUT_KEYSYM_TYPE_ENUM
/**
 * @ingroup iface_wl_webos_xinput
 * the type for the symbol
 *
 * Describes the type of the symbol. The compositor will
 * do the necessary conversion before sending it the the
 * current fullscreen surface
 */
enum wl_webos_xinput_keysym_type {
	WL_WEBOS_XINPUT_KEYSYM_TYPE_QT = 1,
	WL_WEBOS_XINPUT_KEYSYM_TYPE_NATIVE = 2,
};
#endif /* WL_WEBOS_XINPUT_KEYSYM_TYPE_ENUM */

#ifndef WL_WEBOS_XINPUT_EVENT_TYPE_ENUM
#define WL_WEBOS_XINPUT_EVENT_TYPE_ENUM
/**
 * @ingroup iface_wl_webos_xinput
 * the type of the event
 *
 * Describes the type of the event. "press_and_release"
 * means the compositor will send a released event after
 * a pressed event automatically.
 */
enum wl_webos_xinput_event_type {
	WL_WEBOS_XINPUT_EVENT_TYPE_PRESS_AND_RELEASE = 0,
	WL_WEBOS_XINPUT_EVENT_TYPE_PRESS = 1,
	WL_WEBOS_XINPUT_EVENT_TYPE_RELEASE = 2,
};
#endif /* WL_WEBOS_XINPUT_EVENT_TYPE_ENUM */

/**
 * @ingroup iface_wl_webos_xinput
 * @struct wl_webos_xinput_interface
 */
struct wl_webos_xinput_interface {
	/**
	 * invokes an action
	 *
	 * Requests to invoke an action by passing a keysym.
	 */
	void (*invoke_action)(struct wl_client *client,
			      struct wl_resource *resource,
			      uint32_t keysym,
			      uint32_t symbol_type,
			      uint32_t event_type);
	/**
	 * activated
	 *
	 * Notifies the compositor this input has been activated.
	 */
	void (*activated)(struct wl_client *client,
			  struct wl_resource *resource,
			  const char *type);
	/**
	 * deactivated
	 *
	 * Notifies the compositor this input has been deactivated.
	 */
	void (*deactivated)(struct wl_client *client,
			    struct wl_resource *resource);
};

#define WL_WEBOS_XINPUT_ACTIVATION_REQUEST 0
#define WL_WEBOS_XINPUT_DEACTIVATED 1

/**
 * @ingroup iface_wl_webos_xinput
 */
#define WL_WEBOS_XINPUT_ACTIVATION_REQUEST_SINCE_VERSION 1
/**
 * @ingroup iface_wl_webos_xinput
 */
#define WL_WEBOS_XINPUT_DEACTIVATED_SINCE_VERSION 1

/**
 * @ingroup iface_wl_webos_xinput
 */
#define WL_WEBOS_XINPUT_INVOKE_ACTION_SINCE_VERSION 1
/**
 * @ingroup iface_wl_webos_xinput
 */
#define WL_WEBOS_XINPUT_ACTIVATED_SINCE_VERSION 1
/**
 * @ingroup iface_wl_webos_xinput
 */
#define WL_WEBOS_XINPUT_DEACTIVATED_SINCE_VERSION 1

/**
 * @ingroup iface_wl_webos_xinput
 * Sends an activation_request event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
wl_webos_xinput_send_activation_request(struct wl_resource *resource_, const char *type)
{
	wl_resource_post_event(resource_, WL_WEBOS_XINPUT_ACTIVATION_REQUEST, type);
}

/**
 * @ingroup iface_wl_webos_xinput
 * Sends an deactivated event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
wl_webos_xinput_send_deactivated(struct wl_resource *resource_)
{
	wl_resource_post_event(resource_, WL_WEBOS_XINPUT_DEACTIVATED);
}

/**
 * @ingroup iface_wl_webos_xinput_extension
 * @struct wl_webos_xinput_extension_interface
 */
struct wl_webos_xinput_extension_interface {
	/**
	 * register input
	 *
	 * Registers a new xinput.
	 */
	void (*register_input)(struct wl_client *client,
			       struct wl_resource *resource,
			       uint32_t id);
};


/**
 * @ingroup iface_wl_webos_xinput_extension
 */
#define WL_WEBOS_XINPUT_EXTENSION_REGISTER_INPUT_SINCE_VERSION 1

#ifdef  __cplusplus
}
#endif

#endif
